VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SQL Server Developer's Guide - RDO Sample"
   ClientHeight    =   6210
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8520
   LinkTopic       =   "Form1"
   ScaleHeight     =   6210
   ScaleWidth      =   8520
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame3 
      Height          =   15
      Left            =   120
      TabIndex        =   13
      Top             =   6120
      Width           =   2065
   End
   Begin VB.ListBox List1 
      Height          =   4545
      Left            =   2400
      TabIndex        =   1
      Top             =   1080
      Width           =   6015
   End
   Begin VB.TextBox Text_Top 
      Height          =   285
      Left            =   4080
      TabIndex        =   3
      Top             =   1440
      Width           =   2415
   End
   Begin VB.TextBox Text_Mid 
      Height          =   285
      Left            =   4080
      TabIndex        =   5
      Top             =   2040
      Width           =   2415
   End
   Begin VB.TextBox Text_Bot 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   4080
      PasswordChar    =   "*"
      TabIndex        =   7
      Top             =   2640
      Width           =   2415
   End
   Begin VB.CommandButton Command_Cancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   6840
      TabIndex        =   2
      Top             =   5760
      Width           =   1215
   End
   Begin VB.CommandButton Command_Next 
      Caption         =   "&Next -->"
      Default         =   -1  'True
      Height          =   375
      Left            =   5280
      TabIndex        =   0
      Top             =   5760
      Width           =   1215
   End
   Begin VB.Frame Frame1 
      Height          =   15
      Left            =   120
      TabIndex        =   11
      Top             =   1080
      Width           =   2055
   End
   Begin VB.Frame Frame2 
      Height          =   5155
      Left            =   120
      TabIndex        =   12
      Top             =   980
      Width           =   15
   End
   Begin VB.Frame Frame4 
      Caption         =   "Frame4"
      Height          =   5175
      Left            =   2160
      TabIndex        =   14
      Top             =   960
      Width           =   15
   End
   Begin VB.Image Image1 
      Height          =   975
      Left            =   0
      Picture         =   "FormRDO.frx":0000
      Stretch         =   -1  'True
      Top             =   0
      Width           =   8535
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1815
      Left            =   2760
      TabIndex        =   10
      Top             =   1200
      Width           =   5055
   End
   Begin VB.Label Label2 
      Caption         =   "Label2"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2655
      Left            =   2760
      TabIndex        =   9
      Top             =   3240
      Width           =   5415
   End
   Begin VB.Label Label_Top 
      Caption         =   "Server"
      Height          =   255
      Left            =   4080
      TabIndex        =   8
      Top             =   1200
      Width           =   2415
   End
   Begin VB.Label Label_Bot 
      Caption         =   "Password"
      Height          =   255
      Left            =   4080
      TabIndex        =   6
      Top             =   2400
      Width           =   2415
   End
   Begin VB.Label Label_Mid 
      Caption         =   "Login ID"
      Height          =   255
      Left            =   4080
      TabIndex        =   4
      Top             =   1800
      Width           =   2415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1

Dim en As rdoEnvironment
Dim en2 As rdoEnvironment
Dim cn As rdoConnection
Dim cn2 As rdoConnection
Dim rsA As rdoResultset

Dim sServer As String
Dim sLoginID As String
Dim sPassword As String

Dim nState, iLabel As Integer
Dim lbl_Functions(1 To 23) As VB.Label
Dim intTop As Integer

' Displayed by Form_load
Const sCase0_UpperText = "Welcome." & vbCr & vbCr & "This sample program illustrates how to use RDO to perform some of the most common database tasks."
Const sCase0_LowerText = "Press Next to create the rdoEnvironment."

'Displayed by The Next Click
Const sCase1_LowerText = "Congratulations." & vbCr & vbCr & "You have successfully created the rdoEnvironment." & vbCr & vbCr & _
                        "Enter your login ID and Password and then press Next to create a second rdoEnvironment object"

Const sCase2_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created the second rdoEnvironment."
Const sCase2_LowerText = "Press Next to create an rdoConnection using a DSN. The ODBC Administrator will prompt you to select the DSN."

Const sCase3_LowerText = "Congratulations." & vbCr & vbCr & "You have successfully created the rdoConnection using a DSN." & vbCr & vbCr & _
                        "Enter your Server name, login ID and Password and then press Next to create a second rdoConnection object without a DSN"

Const sCase4_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created the DSN-less rdoConnection object."
Const sCase4_LowerText = "Press Next to create an rdoResultset and query the pubs database."

Const sCase5_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created an rdoResultset and queried the pubs database."
Const sCase5_LowerText = "Press Next to create an rdoResultset object using a prepared statement to query the pubs database. "

Const sCase6_LowerText = "Enter a state code from the following list: CA, OR, WA or UT." & vbCr & vbCr & _
                        "Press Next to create an rdoResultset object using a prepared statement to query the pubs database."

Const sCase7_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully ran the prepared statement query."
Const sCase7_LowerText = "Press Next to create a working table named department in the pubs database."

Const sCase8_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created the department table."
Const sCase8_LowerText = "Press Next to create a Keyset result set object and use the cursor to add 50 new rows."

Const sCase9_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully added 50 new rows to the department table."
Const sCase9_LowerText = "Press Next to update 50 rows in the department table using a keyset cursor."

Const sCase10_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully updated 50 rows in the department table."
Const sCase10_LowerText = "Press Next to delete 50 rows in the department table using a keyset cursor."

Const sCase11_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully deleted 50 rows in the department table."
Const sCase11_LowerText = "Press Next to add 50 rows to the department table using the SQL INSERT statement."

Const sCase12_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully added 50 new rows to the department table."
Const sCase12_LowerText = "Press Next to update 50 rows in the department table using the SQL UPDATE statement."

Const sCase13_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully updated 50 rows in the department table."
Const sCase13_LowerText = "Press Next to delete 50 rows in the department table using the SQL DELETE statement."

Const sCase14_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully deleted 50 rows."
Const sCase14_LowerText = "Press Next to create the stored procedure named CountState Rows."

Const sCase15_LowerText = "Congratulations." & vbCr & vbCr & "You have successfully created the CoutStateRows stored procedure." & vbCr & vbCr & _
                        "Press Next to call the stored procedure."

Const sCase16_LowerText = "Congratulations." & vbCr & vbCr & "You have successfully exected the CoutStateRows stored procedure." & vbCr & vbCr & _
                        "Press Next to demonstrate RDO error handling."

Const sCase17_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully demonstrated RDO error handling."
Const sCase17_LowerText = "Press Next to demonstrate RDO's ability to process mutiple result sets."

Const sCase18_LowerText = "Congratulations." & vbCr & vbCr & "You have successfully demonstrated using RDO and multiple results sets." & vbCrLf & vbCrLf _
    & "Press Next to begin an asynchronrous query."

Const sCase19_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully submitted an asynchronous query. The results will be retrieved later."
Const sCase19_LowerText = "Press Next to demonstrate using a server-side cursor."

Const sCase20_LowerText = "Congratulations." & vbCr & vbCr & "You have successfully used a server-side cursor." & vbCrLf & vbCrLf _
    & "Press Next to display the results of the asynchronous query that was submitted earlier"

Const sCase21_LowerText = "Press Next to finish the RDO sample program."

Const sCase22_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully completed the RDO Sample Program."
Const sCase22_LowerText = "Press Next to reset the program or Cancel to end this program."
Private Sub InitRDO()

    MousePointer = vbHourglass
    'Allocate the environment
    Set en = rdoEngine.rdoEnvironments(0)
    MousePointer = vbDefault
    
End Sub
Private Sub Create2ndRDOEnv()
    
    MousePointer = vbHourglass
    'Allocate the environment
    Set en2 = rdoCreateEnvironment("ENV2", Text_Mid.Text, Text_Bot.Text)
    MousePointer = vbDefault
    
End Sub
Private Sub OpenRDOConnectionDSN()
   
    MousePointer = vbHourglass
   'Allocate the connection
    Set cn = en.OpenConnection("", rdDriverComplete)
    MousePointer = vbDefault
    cn.Close
    
End Sub
Private Sub OpenRDOConnectionNoDSN()
    Dim sConn As String
    
    MousePointer = vbHourglass
    sConn = "Driver=SQL Server;SERVER=" & sServer & ";UID=" & sLoginID & ";PWD=" & sPassword & ";DATABASE=pubs"
    'Set cn2 = en.OpenConnection("", rdDriverNoPrompt, False, sConn)
    Set cn = en.OpenConnection("", rdDriverComplete, False, sConn)
    MousePointer = vbDefault

End Sub

Private Sub DynamicQuery(cn As rdoConnection)
    
    Dim rs As rdoResultset
    Dim cl As rdoColumn
    
    MousePointer = vbHourglass
       
    Set rs = cn.OpenResultset("Select au_lname, au_fname From authors", rdOpenForwardOnly)
    
    DisplayRSList List1, rs
    
    rs.Close
        
    MousePointer = vbDefault

End Sub
Private Sub PreparedQuery(cn As rdoConnection)
 
    Dim qy As New rdoQuery
    Dim rs As rdoResultset
    Dim cl As rdoColumn
    Dim sFixedString As String * 15
    Dim sTextLine As String
    
    MousePointer = vbHourglass
    List1.Clear
    
    Set qy.ActiveConnection = cn
    qy.SQL = "Select au_lname, au_fname, state From authors Where state = ?"
    
    qy.rdoParameters(0).Direction = rdParamInput
    qy.rdoParameters(0) = Text_Mid.Text
    
    Set rs = qy.OpenResultset(rdOpenKeyset, rdConcurRowVer)
    
    For Each cl In rs.rdoColumns
        sFixedString = cl.Name
        sTextLine = sTextLine & sFixedString & vbTab
    Next
    
    List1.AddItem sTextLine
    DoEvents
             
    While Not rs.EOF
        sTextLine = vbNullString
        sFixedString = rs!au_lname
        sTextLine = sTextLine & sFixedString & vbTab
        sFixedString = rs!au_Fname
        sTextLine = sTextLine & sFixedString & vbTab
        sFixedString = rs!state
        sTextLine = sTextLine & sFixedString & vbTab
        List1.AddItem sTextLine
        rs.MoveNext
    Wend
    
    rs.Close
    
    MousePointer = vbDefault

End Sub
Private Sub CreateTable(cn As rdoConnection)

    Dim sSQL As String
    On Error Resume Next
    
    sSQL = "Drop Table department"
    cn.Execute sSQL
       
    On Error GoTo 0
    
    sSQL = "Create Table department " _
       & "(Dep_ID Int Not Null, Dep_Name Char(25), " _
       & "Primary Key(Dep_ID))"
    cn.Execute sSQL
     
End Sub
Private Sub AddUsingCursor(cn As rdoConnection)
    
    Dim rs As rdoResultset
    Dim i As Integer
    
    MousePointer = vbHourglass

    Set rs = cn.OpenResultset _
        ("Select Dep_ID, Dep_Name From department", _
        rdOpenKeyset, rdConcurRowVer)
    
    For i = 0 To 50
        rs.AddNew
        rs!Dep_ID = i
        rs!Dep_Name = "Department " & CStr(i)
        rs.Update
    Next
    
    rs.Close
    
    DisplayTableList List1, cn, "department"
    
    MousePointer = vbDefault
    
End Sub
Private Sub UpdateUsingCursor(cn As rdoConnection)
    
    Dim rs As rdoResultset
    Dim i As Integer
    
    MousePointer = vbHourglass
    
    Set rs = cn.OpenResultset("Select Dep_ID, Dep_Name From department", rdOpenKeyset, rdConcurRowVer)
 
    Do Until rs.EOF
        rs.Edit
        rs!Dep_Name = "Updated " & rs!Dep_Name
        rs.Update
        rs.MoveNext
    Loop
    
    rs.Close
    
    DisplayTableList List1, cn, "department"
        
    MousePointer = vbDefault
    
End Sub

Private Sub DeleteUsingCursor(cn As rdoConnection)
    
    Dim rs As rdoResultset
    Dim i As Integer
    
    MousePointer = vbHourglass
    
    Set rs = cn.OpenResultset("Select Dep_ID, Dep_Name From department", rdOpenKeyset, rdConcurRowVer)
    
    Do Until rs.EOF
        rs.Delete
        rs.MoveNext
    Loop
    
    rs.Close
    
    DisplayTableList List1, cn, "department"
    
    MousePointer = vbDefault

End Sub
Private Sub AddUsingInsert(cn As rdoConnection)

    Dim qy As New rdoQuery
    Dim i As Integer
        
    MousePointer = vbHourglass
    
    Set qy.ActiveConnection = cn
    qy.SQL = "Insert Into department Values( ?, ?)"
    
    For i = 0 To 50
        With qy
            .rdoParameters(0).Value = i
            .rdoParameters(1).Value = "INSERTed Department " & CStr(i)
        End With
        qy.Execute
    Next
    
    DisplayTableList List1, cn, "department"

    MousePointer = vbDefault

End Sub
Private Sub UpdateUsingUpdate(cn As rdoConnection)

    Dim qy As New rdoQuery
        
    MousePointer = vbHourglass
    
    Set qy.ActiveConnection = cn
    qy.SQL = "Update department Set Dep_Name = " _
        & "'UPDATE' + Substring(Dep_Name, 7, 25)"
   
    qy.Execute
    
    DisplayTableList List1, cn, "department"
    
    MousePointer = vbDefault

End Sub
Private Sub DeleteUsingDelete(cn As rdoConnection)

    Dim qy As New rdoQuery
       
    MousePointer = vbHourglass
    
    Set qy.ActiveConnection = cn
    qy.SQL = "Delete from department"
    
    qy.Execute
    
    DisplayTableList List1, cn, "department"
    
    MousePointer = vbDefault

End Sub
Private Sub CreateSP(cn As rdoConnection)

    Dim sSQL As String
    On Error Resume Next
    
    sSQL = "Drop Proc CountStateRows"
    cn.Execute sSQL
       
    On Error GoTo 0
    sSQL = "create procedure CountStateRows " _
     & "(@state char(2),@rows int OUTPUT) as " _
     & "select @rows = count(*) from authors where state = @state"

    cn.Execute sSQL
     
End Sub

Private Sub CallSP(cn As rdoConnection)
    
    Dim qy As New rdoQuery
                   
    MousePointer = vbHourglass
    
    Set qy.ActiveConnection = cn
    qy.SQL = "{ call CountStateRows (? ,?) }"
            
    qy.rdoParameters(0).Direction = rdParamInput
    qy.rdoParameters(0).Value = Text_Mid.Text
    qy.rdoParameters(1).Direction = rdParamOutput
    
    qy.Execute
    
    Text_Bot.Text = qy.rdoParameters(1)

    MousePointer = vbDefault

End Sub
Private Sub ShowError(cn As rdoConnection)
    
    Dim sSQL As String
    On Error GoTo RDOError
    
    sSQL = "Drop Table no_such_table"
    cn.Execute sSQL
    Exit Sub
    
RDOError:
    DisplayRDOError

End Sub
Private Sub MultipleRS(cn As rdoConnection)

    Dim qy As New rdoQuery
    Dim rs As rdoResultset
    Dim sSQL As String
    
    MousePointer = vbHourglass
    List1.Clear
    
    'Setup the two SELECT statements
    sSQL = "Select stor_name from stores; "
    sSQL = sSQL & "Select au_lname From authors "
        
    Set qy.ActiveConnection = cn
    qy.SQL = sSQL
    qy.RowsetSize = 1
    
    'Open the first RS
    Set rs = qy.OpenResultset _
            (rdOpenForwardOnly, rdConcurReadOnly)
 
    List1.AddItem "Result set #1"
    While Not rs.EOF
        List1.AddItem rs(0)
        DoEvents
        rs.MoveNext
    Wend
    
    
    'The end of the first RS was reached
    ' Now open the 2nd RS
    
    rs.MoreResults
    
    List1.AddItem ""
    List1.AddItem "Result set #2"
    While Not rs.EOF
        List1.AddItem rs(0)
        DoEvents
        rs.MoveNext
    Wend
    
    rs.Close
        
    MousePointer = vbDefault


End Sub
Private Sub AsynchRSStart(cn As rdoConnection)
    
    Dim sSQL As String
    
    MousePointer = vbHourglass
    
    sSQL = "Select * From authors "
          
    'Start the Async query and move on
    Set rsA = cn.OpenResultset(sSQL, rdOpenForwardOnly, _
                            rdConcurReadOnly, rdAsyncEnable)
        
    MousePointer = vbDefault

End Sub
Private Sub SSCursor(cn As rdoConnection)

    Dim rs As rdoResultset
    Dim cl As rdoColumn
    Dim sFixedString As String * 15
    Dim sTextLine As String

    MousePointer = vbHourglass
    List1.Clear

    ' Use Server side cursor
    en.CursorDriver = rdUseServer
    
    Set rs = cn.OpenResultset _
        ("Select au_lname, au_fname From authors", rdOpenKeyset)
    
    DisplayRSList List1, rs

    rs.Close

    MousePointer = vbDefault

End Sub
Private Sub AsynchRSFinish(cn As rdoConnection)

    Dim sFixedString As String * 15
    Dim sTextLine As String
    Dim cl As rdoColumn

    MousePointer = vbHourglass
    List1.Clear

    If rsA.StillExecuting = False Then
    
        DisplayRSList List1, rsA
        
        rsA.Close
    
    End If
    
    MousePointer = vbDefault


End Sub
Private Sub Reset()
    
    'Close any open connections
    cn.Close
    en2.Close
    en.Close

    'Initialize the program control values
    Label1.Visible = True
    Label2.Visible = True
    Label_Top.Visible = False
    Text_Top.Visible = False
    Label_Mid.Caption = "User ID"
    Label_Mid.Visible = False
    Text_Mid.Visible = False
    Text_Mid.Enabled = True
    Label_Bot.Caption = "Password"
    Label_Bot.Visible = False
    Text_Bot.Visible = False
    Text_Bot.PasswordChar = "*"

    Text_Top.Text = sServer
    Text_Mid.Text = sLoginID
    Text_Bot.Text = sPassword
    
    Label1.Caption = sCase0_UpperText
    Label2.Caption = sCase0_LowerText

End Sub

Private Sub Command_Next_Click()
    If iLabel < 23 Then
        lbl_Functions(iLabel + 1).Enabled = True
        lbl_Functions(iLabel).Enabled = False
    End If
    
    Select Case nState
        Case 1
            InitRDO
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Visible = False
            Label_Mid.Visible = True
            Label_Bot.Visible = True
            Text_Mid.Visible = True
            Text_Bot.Visible = True
            Label2.Caption = sCase1_LowerText
        Case 2
            Create2ndRDOEnv
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Visible = True
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label1.Caption = sCase2_UpperText
            Label2.Caption = sCase2_LowerText
        Case 3
            OpenRDOConnectionDSN
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Visible = False
            Label_Top.Visible = True
            Label_Mid.Visible = True
            Label_Bot.Visible = True
            Text_Top.Visible = True
            Text_Mid.Visible = True
            Text_Bot.Visible = True
            Label2.Caption = sCase3_LowerText
        Case 4
            sServer = Text_Top.Text
            sLoginID = Text_Mid.Text
            sPassword = Text_Bot.Text
            
            OpenRDOConnectionNoDSN
            nState = nState + 1
            sServer = Text_Top.Text
            sLoginID = Text_Mid.Text
            sPassword = Text_Bot.Text
            Label1.Visible = True
            Label_Top.Visible = False
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Top.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label1.Caption = sCase4_UpperText
            Label2.Caption = sCase4_LowerText
        Case 5
            DynamicQuery cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 6
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = False
            Label1.Caption = sCase5_UpperText
            Label2.Caption = sCase5_LowerText
        Case 7
            nState = nState + 1
            Label1.Visible = False
            List1.Visible = False
            Label_Mid.Caption = "Enter the state ID"
            Label_Mid.Visible = True
            Text_Mid.Text = "CA"
            Text_Mid.Visible = True
            Label2.Caption = sCase6_LowerText
        Case 8
            PreparedQuery cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 9
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = False
            Label_Mid.Visible = False
            Text_Mid.Visible = False
            Label1.Visible = True
            Label1.Caption = sCase7_UpperText
            Label2.Caption = sCase7_LowerText
        Case 10
            CreateTable cn
            nState = nState + 1
            Label1.Caption = sCase8_UpperText
            Label2.Caption = sCase8_LowerText
        Case 11
            AddUsingCursor cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 12
            nState = nState + 1
            List1.Visible = False
            Label1.Caption = sCase9_UpperText
            Label2.Caption = sCase9_LowerText
        Case 13
            UpdateUsingCursor cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 14
            nState = nState + 1
            List1.Visible = False
            Label1.Caption = sCase10_UpperText
            Label2.Caption = sCase10_LowerText
        Case 15
            DeleteUsingCursor cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 16
            nState = nState + 1
            List1.Visible = False
            Label1.Caption = sCase11_UpperText
            Label2.Caption = sCase11_LowerText
        Case 17
            AddUsingInsert cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 18
            nState = nState + 1
            List1.Visible = False
            Label1.Caption = sCase12_UpperText
            Label2.Caption = sCase12_LowerText
        Case 19
            UpdateUsingUpdate cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 20
            nState = nState + 1
            List1.Visible = False
            Label1.Caption = sCase13_UpperText
            Label2.Caption = sCase13_LowerText
        Case 21
            DeleteUsingDelete cn
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
        Case 22
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = False
            Label1.Visible = True
            Label1.Caption = sCase14_UpperText
            Label2.Caption = sCase14_LowerText
        Case 23
            CreateSP cn
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = False
            Label1.Visible = False
            Label_Mid.Visible = True
            Label_Mid.Caption = "Enter the state code to query"
            Text_Mid.Visible = True
            Label_Bot.Visible = True
            Label_Bot.Caption = "Number of occurances"
            Text_Bot.Visible = True
            Text_Bot.Text = ""
            Text_Bot.PasswordChar = ""
            Text_Bot.Enabled = False
            Label2.Caption = sCase15_LowerText
        Case 24
            CallSP cn
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Caption = ""
            Label2.Caption = sCase16_LowerText
        Case 25
            ShowError cn
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label1.Visible = True
            Label1.Caption = sCase17_UpperText
            Label2.Caption = sCase17_LowerText
        Case 26
            MultipleRS cn
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
            Label1.Visible = False
            Label_Mid.Visible = False
            Text_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Bot.Visible = False
            Label2.Caption = sCase18_LowerText
        Case 27
            AsynchRSStart cn
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = False
            Label1.Visible = True
            Label_Top.Visible = False
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Top.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label1.Caption = sCase19_UpperText
            Label2.Caption = sCase19_LowerText
        Case 28
            SSCursor cn
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
            Label1.Visible = False
            Label_Top.Visible = False
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Top.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label2.Caption = sCase20_LowerText
        Case 29
            AsynchRSFinish cn
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = True
            Label1.Visible = False
            Label_Top.Visible = False
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Top.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label2.Caption = sCase21_LowerText
        Case 30
            'Finish
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            List1.Visible = False
            Label1.Visible = True
            Label_Top.Visible = False
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Top.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label1.Caption = sCase22_UpperText
            Label2.Caption = sCase22_LowerText
        Case 31
            Reset
            lbl_Functions(iLabel - 13).Visible = False
            nState = 1
            iLabel = 1
            ResetLabels
            lbl_Functions(1).Enabled = True
        End Select
End Sub

Private Sub Form_Activate()
    ' reposition the last labels
    PositionLabels
End Sub

Private Sub Form_Load()
    ' build labels
    BuildLabels
    
    ' set up object if to resize
    InitObjectsToResize Me
    
    'Initialize the program control values
    nState = 1
    iLabel = 1
    List1.Visible = False
    Label_Top.Visible = False
    Text_Top.Visible = False
    Label_Mid.Visible = False
    Text_Mid.Visible = False
    Label_Bot.Visible = False
    Text_Bot.Visible = False

    Label1.Caption = sCase0_UpperText
    Label2.Caption = sCase0_LowerText
    
End Sub
Private Sub DisplayRDOError()
        
    Dim er As RDOError
    
    For Each er In rdoErrors
        MsgBox "Number: " & er.Number & vbCrLf & _
        "SQL State: " & er.SQLState & vbCrLf & _
        "Text: " & er.Description
    Next
        
End Sub
Private Sub Form_Resize()
    ' resize the forms objects
    ResizeObjects Me
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    On Error Resume Next
    
    en2.Close
    en.Close
    Set en2 = Nothing
    Set en = Nothing
End Sub
Private Sub Command_Cancel_Click()
    End
End Sub
Private Sub DisplayTableList(oList As ListBox, cn As rdoConnection, sTable As String)
    
    Dim rs As rdoResultset
    Dim cl As rdoColumn
    Dim sTextLine As String
    Dim sFixedString As String * 20
   
    Set rs = cn.OpenResultset("Select * From " & sTable, rdOpenForwardOnly)
    
    oList.Clear
    
    For Each cl In rs.rdoColumns
        sFixedString = cl.Name
        sTextLine = sTextLine & sFixedString & vbTab
    Next
    
    oList.AddItem sTextLine
    
    Do While Not rs.EOF
        sTextLine = ""
        For Each cl In rs.rdoColumns
            sFixedString = cl.Value
            sTextLine = sTextLine & sFixedString & vbTab
        Next
        
        oList.AddItem sTextLine
        DoEvents
        
        rs.MoveNext
        
    Loop
    
    rs.Close

End Sub

Private Sub DisplayRSList(oList As ListBox, rs As rdoResultset)
    
    Dim cl As rdoColumn
    Dim sTextLine As String
    Dim sFixedString As String * 20
    
    oList.Clear
    
    For Each cl In rs.rdoColumns
        sFixedString = cl.Name
        sTextLine = sTextLine & sFixedString & vbTab
    Next
    
    oList.AddItem sTextLine
    DoEvents
   
    Do While Not rs.EOF
        sTextLine = ""
        For Each cl In rs.rdoColumns
            sFixedString = cl.Value
            sTextLine = sTextLine & sFixedString & vbTab
        Next
        
        oList.AddItem sTextLine
        DoEvents
        
        rs.MoveNext
    Loop

End Sub




Public Sub InitObjectsToResize(frm As Form)
    Dim obj As Object
    On Error Resume Next
    For Each obj In frm.Controls
        If obj.Left < 0 Then obj.Left = 0
        If obj.Top < 0 Then obj.Top = 0
        If obj.Top > frm.ScaleHeight Then obj.Top = frm.ScaleHeight - 360
        If obj.Width > frm.ScaleWidth Then obj.Width = frm.ScaleWidth
        If obj.Height > frm.ScaleHeight Then obj.Height = frm.ScaleHeight
        obj.Tag = Format$(obj.Left / frm.ScaleWidth, ".0000") _
                & Format$(obj.Top / frm.ScaleHeight, ".0000") _
                & Format$(obj.Width / frm.ScaleWidth, ".0000") _
                & Format$(obj.Height / frm.ScaleHeight, ".0000")
    Next obj
End Sub

Public Sub ResizeObjects(frm As Form)
    Dim obj As Object
    On Error Resume Next
    For Each obj In frm.Controls
        obj.Move Val(Mid$(obj.Tag, 1, 5)) * frm.ScaleWidth, _
                Val(Mid$(obj.Tag, 6, 5)) * frm.ScaleHeight, _
                Val(Mid$(obj.Tag, 11, 5)) * frm.ScaleWidth, _
                Val(Mid$(obj.Tag, 16, 5)) * frm.ScaleHeight
    Next obj
    
    intTop = lbl_Functions(2).Top - lbl_Functions(1).Top
    PositionLabels
End Sub

Public Sub BuildLabels()
    Dim iCount, iTop As Integer
    
    iTop = 1200
    For iCount = 1 To 23
        Set lbl_Functions(iCount) = Form1.Controls.Add("VB.Label", "lbl_Functions" & iCount, Me)
        lbl_Functions(iCount).AutoSize = True
        lbl_Functions(iCount).Enabled = False
        lbl_Functions(iCount).Height = 195
        lbl_Functions(iCount).Left = 230
        lbl_Functions(iCount).Top = iTop
        lbl_Functions(iCount).Visible = True
        Select Case iCount
            Case 1
                lbl_Functions(iCount).Caption = "Create Environment"
                lbl_Functions(iCount).Enabled = True
            Case 2
                lbl_Functions(iCount).Caption = "Create 2nd Environment"
            Case 3
                lbl_Functions(iCount).Caption = "DSN Connection"
            Case 4
                lbl_Functions(iCount).Caption = "DSN-less Connection"
            Case 5
                lbl_Functions(iCount).Caption = "Create Recordset"
            Case 6
                lbl_Functions(iCount).Caption = "Prepared Query"
            Case 7
                lbl_Functions(iCount).Caption = "Prepared Query"
            Case 8
                lbl_Functions(iCount).Caption = "Create Table"
            Case 9
                lbl_Functions(iCount).Caption = "Add rows w/Keyset"
            Case 10
                lbl_Functions(iCount).Caption = "Update rows w/Keyset"
            Case 11
                lbl_Functions(iCount).Caption = "Delete rows w/Keyset"
            Case 12
                lbl_Functions(iCount).Caption = "Add w/SQL INSERT"
            Case 13
                lbl_Functions(iCount).Caption = "Update w/SQL UPDATE"
            Case 14
                lbl_Functions(iCount).Caption = "Delete w/SQL DELETE"
            ' build controls on page to allow resizing. will position them later
            Case 15
                lbl_Functions(iCount).Top = iTop - 360
                lbl_Functions(iCount).Caption = "Create Stored Procedure"
            Case 16
                lbl_Functions(iCount).Top = iTop - 360
                lbl_Functions(iCount).Caption = "Call Stored Procedure"
            Case 17
                lbl_Functions(iCount).Top = iTop - 360 * 2
                lbl_Functions(iCount).Caption = "Show Error"
            Case 18
                lbl_Functions(iCount).Top = iTop - 360 * 3
                lbl_Functions(iCount).Caption = "Multiple Recordsets"
            Case 19
                lbl_Functions(iCount).Top = iTop - 360 * 4
                lbl_Functions(iCount).Caption = "Async Query"
            Case 20
                lbl_Functions(iCount).Top = iTop - 360 * 5
                lbl_Functions(iCount).Caption = "Server-side Cursor"
            Case 21
                lbl_Functions(iCount).Top = iTop - 360 * 6
                lbl_Functions(iCount).Caption = "Async Query Results"
            Case 22
                lbl_Functions(iCount).Top = iTop - 360 * 7
                lbl_Functions(iCount).Caption = "Finish"
            Case 23
                lbl_Functions(iCount).Top = iTop - 360 * 8
                lbl_Functions(iCount).Caption = "Reset"
        End Select
        iTop = iTop + 360
    Next iCount
    intTop = 360
End Sub

Public Sub PositionLabels()
    Dim iScrollMove, iTop As Integer
    iTop = (intTop * 14) + lbl_Functions(1).Top
    For iScrollMove = 1 To 9
        lbl_Functions(iScrollMove + 14).Top = iTop
        iTop = iTop + intTop
    Next iScrollMove
End Sub

Public Sub ResetLabels()
    Dim iScrollMove, iTop As Integer
    iTop = (intTop * 9) + lbl_Functions(1).Top
    For iScrollMove = 1 To 23
        lbl_Functions(iScrollMove).Visible = True
        lbl_Functions(iScrollMove).Top = iTop
        iTop = iTop + intTop
    Next iScrollMove
End Sub

Public Sub ShiftLabels(iShift As Integer)
    Dim iMove As Integer
    lbl_Functions(iShift).Visible = False
    For iMove = 1 To 14
        lbl_Functions(iMove).Top = (Val(Mid$(lbl_Functions(iMove).Tag, 6, 5)) * Me.ScaleHeight) - (intTop * iShift)
    Next iMove
    For iMove = 15 To 23
        lbl_Functions(iMove).Top = lbl_Functions(iMove).Top - intTop
    Next iMove
End Sub

