VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "SQL Server Developer's Guide - DAO Sample"
   ClientHeight    =   6210
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8520
   LinkTopic       =   "Form1"
   ScaleHeight     =   6210
   ScaleWidth      =   8520
   StartUpPosition =   2  'CenterScreen
   Begin MSFlexGridLib.MSFlexGrid Grid 
      Height          =   4575
      Left            =   2400
      TabIndex        =   6
      Top             =   1080
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   8070
      _Version        =   393216
      FixedCols       =   0
      AllowUserResizing=   1
   End
   Begin VB.TextBox Text_Mid 
      Height          =   285
      Left            =   4080
      TabIndex        =   8
      Top             =   2160
      Width           =   2415
   End
   Begin VB.TextBox Text_Bot 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   4080
      PasswordChar    =   "*"
      TabIndex        =   9
      Top             =   2760
      Width           =   2415
   End
   Begin VB.TextBox Text_Top 
      Height          =   285
      Left            =   4080
      TabIndex        =   7
      Top             =   1560
      Width           =   2415
   End
   Begin VB.Frame Frame5 
      Caption         =   "Frame4"
      Height          =   5175
      Left            =   2160
      TabIndex        =   5
      Top             =   960
      Width           =   15
   End
   Begin VB.Frame Frame4 
      Height          =   5155
      Left            =   120
      TabIndex        =   4
      Top             =   975
      Width           =   15
   End
   Begin VB.Frame Frame2 
      Height          =   15
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   2055
   End
   Begin VB.Frame Frame3 
      Height          =   15
      Left            =   120
      TabIndex        =   2
      Top             =   6120
      Width           =   2065
   End
   Begin VB.CommandButton Command_Cancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   6840
      TabIndex        =   1
      Top             =   5760
      Width           =   1215
   End
   Begin VB.CommandButton Command_Next 
      Caption         =   "Next-->"
      Default         =   -1  'True
      Height          =   375
      Left            =   5160
      TabIndex        =   0
      Top             =   5760
      Width           =   1335
   End
   Begin VB.Label Label2 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2655
      Left            =   2760
      TabIndex        =   14
      Top             =   3240
      Width           =   5415
   End
   Begin VB.Label Label1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1815
      Left            =   2760
      TabIndex        =   13
      Top             =   1200
      Width           =   5055
   End
   Begin VB.Label Label_Mid 
      Caption         =   "Login ID"
      Height          =   255
      Left            =   4080
      TabIndex        =   12
      Top             =   1920
      Width           =   2415
   End
   Begin VB.Label Label_Bot 
      Caption         =   "Password"
      Height          =   255
      Left            =   4080
      TabIndex        =   11
      Top             =   2520
      Width           =   2415
   End
   Begin VB.Label Label_Top 
      Caption         =   "Server"
      Height          =   255
      Left            =   4080
      TabIndex        =   10
      Top             =   1320
      Width           =   2415
   End
   Begin VB.Image Image1 
      Height          =   975
      Left            =   0
      Picture         =   "FormDAO.frx":0000
      Stretch         =   -1  'True
      Top             =   0
      Width           =   8535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim ws As DAO.Workspace
Dim db As DAO.Database
Dim rs As DAO.Recordset
Dim td As DAO.TableDef

Dim sServer As String
Dim sLoginID As String
Dim sPassword As String

Dim nState, iLabel As Integer
Dim lbl_Functions(1 To 23) As VB.Label
Dim intTop As Integer

' Displayed by Form_load
Const sCase0_UpperText = "Welcome." & vbCr & vbCr & "This sample program illustrates how to use DAO to build SQL Server database applicaitons."
Const sCase0_LowerText = "Press Next to enter your SQL Server connection information."

Const sCase1_LowerText = vbCr & "Enter the name of your SQL Server system and a valid Login ID and Password." & vbCr & vbCr & _
                        "To successfully perfom all of the tasks in this program this ID must have create table authority to the pubs database." & vbCr & vbCr & _
                        "Press Next to connect to the SQL Server pubs database using a Linked Table."

Const sCase2_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully connected to SQL Server using a Linked table."
Const sCase2_LowerText = "Press Next to dynamically create a new linked table and use it to connect to the pubs database."

Const sCase3_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully connected to SQL Server using a dynamically created linked table."
Const sCase3_LowerText = "Press Next to connect to SQL Server using the OpenDatabase method.  You will be prompted to select an existing DSN to make the connection."

Const sCase4_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully connected to SQL Server using the OpenDatabase method and selecting a DSN"
Const sCase4_LowerText = "Press Next to connect to the pubs database using a DSN-less connection."

Const sCase5_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully connected to SQL Server using a DSN-less OpenDatabase connection."
Const sCase5_LowerText = "Press Next to open a Dynaset type of recordset and query the author table in the pubs database.  The results will be displayed in a grid."

Const sCase6_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully queried the authors table using a Dynaset type of recordset."
Const sCase6_LowerText = "Press Next to use the FindFirst method to display the rows in the recordset where the state is CA."

Const sCase7_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully used the FindFirst method to find the first row in the recordset where the state was CA."
Const sCase7_LowerText = "Press Next the use the FindNext method to display all of the remaining rows in the recordset where the state is CA."

Const sCase8_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully used the FindNext method to list all of the rows in the recordset where the state equals CA."
Const sCase8_LowerText = "Press Next to use the FindLast and FindPrevious methods to locate all of the rows where the state is CA and the city is Oakland." & vbCr & _
                        "This action will list the occurances of each match starting from the end of the recordset working backward to the beginning."

Const sCase9_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully used the FindLast and FindPrevious methods."
Const sCase9_LowerText = "Press Next to create a recordset that limits he rows to only those rows where the state column contains the value of CA and the city column contains the value of Oakland."

Const sCase10_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully limited the recordset to just the rows in the authors table where the state contains the value of CA and the city column contains the value of Oakland."
Const sCase10_LowerText = "Press Next to create a new table in the pubs database named department."

Const sCase11_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully created the department table in the pubs database."
Const sCase11_LowerText = "Press Next to add 50 rows to the department table using a Dynaset type of recordset."

Const sCase12_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully added 50 rows to the new department table in the pubs database."
Const sCase12_LowerText = "Press Next to update to 50 rows contained in the department table using a Dynaset type of recordset."

Const sCase13_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully updated 50 rows in the department table of the pubs database."
Const sCase13_LowerText = "Press Next to delete 50 rows in the department table using a Dynaset type of recordset."

Const sCase14_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully deleted 50 rows in the department table of the pubs database."
Const sCase14_LowerText = "Press Next to add 50 rows in the department table using SQLPassthrough"

Const sCase15_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully added 50 rows to the department table of the pubs database."
Const sCase15_LowerText = "Press Next to update 50 rows in the department table using SQLPassthrough"

Const sCase16_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully updated 50 rows in the department table of the pubs database."
Const sCase16_LowerText = "Press Next to delete 50 rows in the department table using SQLPassthrough"

Const sCase17_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully deleted 50 rows in the department table of the pubs database."
Const sCase17_LowerText = "Press Next to run a QueryDef with paraemters using the linked authors table.  This QueryDef selects the rows in the authors table that contain a value of 'OR' in the state column"

Const sCase18_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully ran the stored QueryDef to retieve all of the rows in he author's table where the state contained the value of 'OR'."
Const sCase18_LowerText = "Press Next to execute using an SQLPassthru QueryDef.  This SQLPassthrough query selects lists the authors from the authors table with their titles from the titles table."

Const sCase19_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully run the SQLPassthru QueryDef."
Const sCase19_LowerText = "Press Next to call the sample reptq1 stored procedure in the pubs database." & vbCr & _
                        "This stored procedure returns 7 results sets that are processed using an SQLPassthru QueryDef object."

Const sCase20_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully called the reptq1 stored procedure and displayed the contents of all 7 result sets in the grid."
Const sCase20_LowerText = "Press next to illustrate an sample DAO error handling."

Const sCase21_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully illustrated DAO Error handling."
Const sCase21_LowerText = "Press Next to finish the DAO sample program."

Const sCase22_UpperText = "Congratulations." & vbCr & vbCr & "You have successfully completed the DAO Sample program."
Const sCase22_LowerText = "Press Next to reset the program or Cancel to end this program."
Private Sub ConnectLinkedTable()
    
    MousePointer = vbHourglass
            
    Set db = DAO.OpenDatabase(App.Path & "\pubslink.mdb")
    
    db.Connect = "ODBC;DSN=TECA SQL Server;"
    
    Set rs = db.OpenRecordset("Select * From authors")
    
    Do Until rs.EOF
        Debug.Print rs(0), rs(1), rs(2)
        rs.MoveNext
    Loop
    
    rs.Close
    db.Close
            
    MousePointer = vbDefault

End Sub
Private Sub CreateLinkedTable _
    (ws As DAO.Workspace, db As DAO.Database, _
    td As DAO.TableDef, rs As DAO.Recordset, _
    sServer As String, sLogin As String, sPassword As String)

    MousePointer = vbHourglass
    
    Set ws = DBEngine.Workspaces(0)
    
    Set db = ws.CreateDatabase _
        ("c:\temp\newlink.mdb", dbLangGeneral, dbVersion30)
    Set td = db.CreateTableDef("authors")
    td.Connect = "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";SERVER=" & sServer & _
        ";DATABASE=pubs"
    td.SourceTableName = "dbo.authors"
    db.TableDefs.Append td
    Set rs = db.OpenRecordset("Select * From authors")
    
    Do Until rs.EOF
        Debug.Print rs(0), rs(1), rs(2)
        rs.MoveNext
    Loop
            
    rs.Close
    db.Close
    ws.Close
    
    Kill ("c:\temp\newlink.mdb")
    
    MousePointer = vbDefault
    
End Sub

Private Sub ConnectOpenDatabase _
    (ws As DAO.Workspace, db As DAO.Database, _
    sLogin As String, sPassword As String)
    
    MousePointer = vbHourglass
    
    Set ws = Workspaces(0)
    Set db = ws.OpenDatabase _
        ("", dbDriverComplete, False, "ODBC;UID=" & sLoginID & _
        ";PWD=" & sPassword & ";DATABASE=pubs")
    Set rs = db.OpenRecordset("Select * From authors")
    
    rs.Close
    db.Close
    ws.Close
    
    MousePointer = vbDefault
    
End Sub
Private Sub DSNlessConnectOpenDatabase _
    (ws As DAO.Workspace, db As DAO.Database, _
    sServer As String, sLoginID As String, sPassword As String)
    
    MousePointer = vbHourglass
    
    Set db = ws.OpenDatabase("", dbDriverNoPrompt, False, _
        "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";SERVER=" & sServer & _
        ";DATABASE=pubs")
    Set rs = db.OpenRecordset("Select * From authors")
        
    MousePointer = vbDefault
    
End Sub
Private Sub DAOQuery()
    
    Dim ws As DAO.Workspace
    Dim db As DAO.Database
    Dim rs As DAO.Recordset
    Dim fld As Field
    Dim nRow As Integer
    
    MousePointer = vbHourglass
    
    Set ws = Workspaces(0)
    Set db = ws.OpenDatabase _
        ("", dbDriverComplete, False, "ODBC;UID=" & sLoginID & _
        ";PWD=" & sPassword & ";DATABASE=pubs")
    Set rs = db.OpenRecordset("Select * From authors", dbOpenDynaset)
        
    'Display the recordset in a grid
    DisplayDynasetGrid rs, Grid, 1
       
    rs.Close
        
    MousePointer = vbDefault

End Sub
Private Sub DAORecordSetFindFirst(db As DAO.Database)
    
    Dim rs As Recordset
    Dim fld As Field
    Dim sCriteria As String
    
    MousePointer = vbHourglass
    
    'Use the open database object named db
    Set rs = db.OpenRecordset _
      ("Select au_id, au_lname, au_fname, state From authors", _
      dbOpenDynaset)
    
    'Setup the find criteria
    sCriteria = "state = 'CA'"
    
    ' Find the first matching record
    rs.FindFirst sCriteria
    If rs.NoMatch Then
        MsgBox "No records found for " & sCriteria
        MousePointer = vbDefault
        Exit Sub
    End If

    ' Setup the grid
    Grid.Cols = rs.Fields.Count
    Grid.Rows = 2
    Grid.Row = 0
    
    'Setup the Grid headings
     For Each fld In rs.Fields
         Grid.Col = fld.OrdinalPosition
         Grid.Text = fld.Name
    Next fld
    
    Grid.Row = Grid.Row + 1
    
    'Display one row in the grid
    For Each fld In rs.Fields
        Grid.Col = fld.OrdinalPosition
        Grid.Text = fld.Value
    Next fld
    
    rs.Close
                    
    MousePointer = vbDefault

End Sub

Private Sub DAORecordSetFindNext(db As DAO.Database)
    Dim fld As Field
    Dim sCriteria As String
    
    MousePointer = vbHourglass
    
    'Use the open database object named db
    Set rs = db.OpenRecordset _
      ("Select au_id, au_lname, au_fname, state, city From authors", _
      dbOpenDynaset)
      
    ' Setup the grid
    Grid.Cols = rs.Fields.Count
    Grid.Rows = 1
    Grid.Row = 0
    
    'Setup the Grid headings
     For Each fld In rs.Fields
         Grid.Col = fld.OrdinalPosition
         Grid.Text = fld.Name
    Next fld
    
    'Setup the find criteria
    sCriteria = "state = 'CA'"
    
    ' Find the first matching record
    rs.FindFirst sCriteria
    
    Do While rs.NoMatch = False
        'Display the current record in the grid
        Grid.Rows = Grid.Rows + 1
        Grid.Row = Grid.Rows - 1
        
        For Each fld In rs.Fields
            Grid.Col = fld.OrdinalPosition
            Grid.Text = fld.Value
        Next fld
        rs.FindNext sCriteria
   Loop
                
    MousePointer = vbDefault
 
 End Sub
 Private Sub DAORecordsetFindLast(rs As DAO.Recordset)
    Dim fld As Field
    Dim sCriteria As String
    
    MousePointer = vbHourglass
    
    ' Setup the grid
    Grid.Cols = rs.Fields.Count
    Grid.Rows = 1
    Grid.Row = 0
    
    'Setup the find criteria
    sCriteria = "state = 'CA' And city = 'Oakland'"
    
    ' Find the first matching record
    ' Use the open recordset named rs
    rs.FindLast sCriteria
    If rs.NoMatch Then
        MsgBox "No records found for " & sCriteria
        MousePointer = vbDefault
        Exit Sub
    End If
                
    ' Find the first matching records in the open recordset
    Do While rs.NoMatch = False
        'Display the current record in the grid
        If rs.NoMatch = True Then Exit Do
        
        Grid.Rows = Grid.Rows + 1
        Grid.Row = Grid.Rows - 1
        
        For Each fld In rs.Fields
            Grid.Col = fld.OrdinalPosition
            Grid.Text = fld.Value
        Next fld
        rs.FindPrevious sCriteria
    Loop
    
    rs.Close
                
    MousePointer = vbDefault
    
 End Sub
 
 Private Sub DAOLimitedRecordSet()
 
    Dim ws As Workspace
    Dim db As Database
    Dim rs As Recordset
    Dim fld As Field
    Dim nRow As Integer
    Dim sSQL As String
    
    MousePointer = vbHourglass
    
    sSQL = "Select au_lname, au_fname, city, state From authors " _
        & "Where state = 'CA' And city = 'Oakland'"
    
    Set ws = Workspaces(0)
    Set db = ws.OpenDatabase("", dbDriverNoPrompt, False, _
        "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";Server=" & sServer & _
        ";Database=pubs")
    Set rs = db.OpenRecordset(sSQL, dbOpenDynaset)
    
    DisplayDynasetGrid rs, Grid, 1
    
    rs.Close
        
    MousePointer = vbDefault

 End Sub
 

Private Sub CreateTable(db As DAO.Database)

    Dim sSQL As String
    On Error Resume Next
    
    MousePointer = vbHourglass
    
    sSQL = "Drop Table department"
    db.Execute sSQL, dbSQLPassThrough
       
    On Error GoTo 0
    sSQL = "Create Table department " _
        & "(Dep_ID Int Not Null, Dep_Name Char(25), Primary Key(Dep_ID))"
    db.Execute sSQL, dbSQLPassThrough
    
    MousePointer = vbDefault
     
End Sub
Private Sub AddUsingRecordset(db As DAO.Database)
    
    Dim rs As Recordset
    Dim i As Integer
    Dim sSQL As String
    
    MousePointer = vbHourglass
    
    ' Make sure no records are retrieved on the SELECT
    sSQL = "Select Dep_ID, Dep_Name From department Where 1 = 2"
    
    'Use the open database object
    Set rs = db.OpenRecordset(sSQL, dbOpenDynaset)
   
    ' Insert 50 records
    For i = 1 To 50
        rs.AddNew
        rs!Dep_ID = i
        rs!Dep_Name = "Department " & CStr(i)
        rs.Update
    Next
    
    ' Display the added records
    DisplayDynasetGrid rs, Grid, 1
       
    rs.Close
    
    MousePointer = vbDefault
    
End Sub
Private Sub UpdateUsingRecordset(db As DAO.Database)
    
    Dim rs As Recordset
    Dim i As Integer
    Dim sTemp As String
    
    MousePointer = vbHourglass
    
    'Open an updateable record set
    ' using the exisiting Database object db
    Set rs = db.OpenRecordset _
        ("Select Dep_ID, Dep_name From department", dbOpenDynaset)
 
    ' Update all of the rows in the department table
    Do Until rs.EOF
        rs.Edit
        ' Jet returns blank filled strings -- truncate at the first blank
        sTemp = RTrim(rs!Dep_Name)
        rs!Dep_Name = "Updated " & sTemp
        rs.Update
        rs.MoveNext
    Loop
    
    ' Display the updated records
    DisplayDynasetGrid rs, Grid, 1
    
    rs.Close
    
    MousePointer = vbDefault
    
End Sub

Private Sub DeleteUsingRecordset(db As DAO.Database)
    
    Dim rs As Recordset
    Dim i As Integer
    
    MousePointer = vbHourglass
    
    'Open an updateable recordset using an existing Database object
    Set rs = db.OpenRecordset("Select * From department", dbOpenDynaset)
    
    ' Delete all of the rows in the department table
    Do Until rs.EOF
        rs.Delete
        rs.MoveNext
    Loop
    
    ' Display the empty records
    DisplayDynasetGrid rs, Grid, 1
        
    rs.Close
    
    MousePointer = vbDefault

End Sub
Private Sub AddUsingInsert(db As DAO.Database)

    Dim i As Integer
    Dim sSQL As String
    Dim rs As DAO.Recordset
    On Error GoTo Errorhandler
    
    MousePointer = vbHourglass
    
    ' No recordset is needed
    For i = 1 To 50
        sSQL = "Insert Into department " & _
            "Values('" & CStr(i) & "','DEPARTMENT " & CStr(i) & "')"
        db.Execute sSQL, dbSQLPassThrough
    Next
    
    ' Create a recordset to display the updated table
    Set rs = db.OpenRecordset("Select * From department", dbOpenDynaset)
    DisplayDynasetGrid rs, Grid, 1
    rs.Close
   
    MousePointer = vbDefault
    Exit Sub
    
Errorhandler:
    DisplayDAOError
    
    MousePointer = vbDefault

End Sub
Private Sub UpdateUsingUpdate(db As DAO.Database)

    Dim sSQL As String
    Dim rs As DAO.Recordset
    On Error GoTo Errorhandler
            
    MousePointer = vbHourglass
    
    sSQL = "Update department " & _
        "Set Dep_Name = 'UPDATE' + Substring(Dep_Name, 7, 25)"
    
    db.Execute sSQL, dbSQLPassThrough
    
    ' Create a recordset to display the updated table
    Set rs = db.OpenRecordset("Select * From department", dbOpenDynaset)
    DisplayDynasetGrid rs, Grid, 1
    rs.Close
       
    MousePointer = vbDefault
    Exit Sub
    
Errorhandler:
    DisplayDAOError

    MousePointer = vbDefault

End Sub
Private Sub DeleteUsingDelete(db As DAO.Database)

    Dim sSQL As String
    Dim rs As DAO.Recordset
    On Error GoTo Errorhandler
       
    MousePointer = vbHourglass
    
    sSQL = "Delete department"
    db.Execute sSQL, dbSQLPassThrough
    
    ' Create a recordset to display the updated table
    Set rs = db.OpenRecordset("Select * From department", dbOpenDynaset)
    DisplayDynasetGrid rs, Grid, 1
    rs.Close
       
    MousePointer = vbDefault
    Exit Sub
   
Errorhandler:
    DisplayDAOError
    
   MousePointer = vbDefault

End Sub
Private Sub QueryDefParms()
    
    Dim db As Database
    Dim qd As QueryDef
    Dim rs As Recordset
    Dim fld As Field
    
    Dim sSQL As String
    On Error GoTo Errorhandler
   
    MousePointer = vbHourglass
    
    sSQL = "Parameters sInputState Text; " _
        & "Select au_lname, au_fname, state From authors " _
        & "Where state = sInputState ;"
    
    Set db = OpenDatabase(App.Path & "\pubslink.mdb")
    
    Set td = db.TableDefs("authors")
    td.Connect = "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";SERVER=" & sServer & _
        ";DATABASE=pubs"
    
    On Error Resume Next
     db.QueryDefs.Delete ("StateQuery")
  
    On Error GoTo Errorhandler
    Set qd = db.CreateQueryDef("StateQuery", sSQL)
  
    qd.Parameters("sInputState") = "OR"
  
    Set rs = qd.OpenRecordset()
  
    DisplayDynasetGrid rs, Grid, 1

    rs.Close
    qd.Close
    db.Close
  
    MousePointer = vbDefault
    Exit Sub
   
Errorhandler:
    DisplayDAOError
    
   MousePointer = vbDefault
   
End Sub

Private Sub QDSQLPassthru()
    Dim db As Database
    Dim qd As QueryDef
    Dim rs As Recordset
    Dim fld As Field
    
    Dim i As Integer
    Dim sSQL As String
    On Error GoTo Errorhandler
   
    MousePointer = vbHourglass
    
    sSQL = "Select au_lname, au_fname, title " _
        & "From authors, titles, titleauthor " _
        & "Where authors.au_id = titleauthor.au_id " _
        & "And titles.title_id = titleauthor.title_id " _
        & "Order By au_lname"
    
    Set db = OpenDatabase(App.Path & "\pubslink.mdb")

    On Error Resume Next
    db.QueryDefs.Delete ("QDPassthru")
  
    On Error GoTo Errorhandler
    Set qd = db.CreateQueryDef("QDPassthru")
    qd.Connect = "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";SERVER=" & sServer & _
        ";DATABASE=pubs"
    qd.SQL = sSQL
    qd.ReturnsRecords = True
          
    Set rs = qd.OpenRecordset()
  
    DisplayDynasetGrid rs, Grid, 1
    
    rs.Close
    qd.Close
    db.Close
    
    MousePointer = vbDefault
    Exit Sub
   
Errorhandler:
    DisplayDAOError

   MousePointer = vbDefault

End Sub
Private Sub CallQDsp()
    
    Dim db As Database
    Dim qd As QueryDef
    Dim rs As Recordset
    Dim fld As Field
    
    Dim sSQL As String
    On Error GoTo Errorhandler
                   
    MousePointer = vbHourglass
    
    Set db = OpenDatabase(App.Path & "\pubslink.mdb")
   
    sSQL = "reptq1"
    
    On Error Resume Next
    db.QueryDefs.Delete ("QDsp")
  
    On Error GoTo Errorhandler
    Set qd = db.CreateQueryDef("QDsp")
    qd.Connect = "ODBC;Driver=SQL Server;UID=" & sLoginID & _
        ";PWD=" & sPassword & _
        ";SERVER=" & sServer & _
        ";DATABASE=pubs"
    qd.SQL = sSQL
    qd.ReturnsRecords = True
          
    Set rs = qd.OpenRecordset()
  
    ' Setup the grid
    Grid.Cols = rs.Fields.Count
    Grid.Rows = 1
    Grid.Row = 0
    
    'Setup the Grid headings
     For Each fld In rs.Fields
         Grid.Col = fld.OrdinalPosition
         Grid.Text = fld.Name
    Next fld
        
    On Error Resume Next
    db.TableDefs.Delete "SPrs"
    db.TableDefs.Delete "SPrs1"
    db.TableDefs.Delete "SPrs2"
    db.TableDefs.Delete "SPrs3"
    db.TableDefs.Delete "SPrs4"
    db.TableDefs.Delete "SPrs5"
    db.TableDefs.Delete "SPrs6"

    On Error GoTo Errorhandler
        
    'Now process the next result set using a JET table
    Set qd = db.CreateQueryDef("")
    qd.SQL = "Select [QDsp].* Into SPrs From [QDsp]"
    qd.Execute
    
    Set rs = db.OpenRecordset("SPrs")
    
    rs.MoveLast
    Grid.Rows = Grid.Rows + rs.RecordCount
    Grid.Row = 0
    rs.MoveFirst
    
    ' Move through each row in the record set
    Do Until rs.EOF
    
        Grid.Row = Grid.Row + 1
           
        'Loop through all fields
        For Each fld In rs.Fields
            Grid.Col = fld.OrdinalPosition
            Grid.Text = fld.Value
        Next fld
    
        rs.MoveNext
    Loop
        
    'Get the second result set
    Set rs = db.OpenRecordset("SPrs1")
    
    Grid.Rows = Grid.Rows + 1
    Grid.Row = Grid.Row + 1
           
    Grid.Col = 1
    Grid.Text = "Average"
    Grid.Col = 2
    Grid.Text = rs(0).Value
    
    'Now get the 3rd result set
    Set rs = db.OpenRecordset("SPrs2")
    
    rs.MoveLast
    Grid.Rows = Grid.Rows + rs.RecordCount
    rs.MoveFirst
    
    ' Move through each row in the record set
    Do Until rs.EOF
    
        Grid.Row = Grid.Row + 1
           
        'Loop through all fields
        For Each fld In rs.Fields
            Grid.Col = fld.OrdinalPosition
            Grid.Text = fld.Value
        Next fld
    
        rs.MoveNext
    Loop
        
    'Get the 4th result set
    Set rs = db.OpenRecordset("SPrs3")
    
    Grid.Rows = Grid.Rows + 1
    Grid.Row = Grid.Row + 1
           
    Grid.Col = 1
    Grid.Text = "Average"
    Grid.Col = 2
    Grid.Text = rs(0).Value
    
    'Now process the 5th
    Set rs = db.OpenRecordset("SPrs4")
    
    rs.MoveLast
    Grid.Rows = Grid.Rows + rs.RecordCount
    rs.MoveFirst
    
    ' Move through each row in the record set
    Do Until rs.EOF
    
        Grid.Row = Grid.Row + 1
           
        'Loop through all fields
        For Each fld In rs.Fields
            Grid.Col = fld.OrdinalPosition
            Grid.Text = fld.Value
        Next fld
    
        rs.MoveNext
    Loop
        
    'Get the 6th result set
    Set rs = db.OpenRecordset("SPrs5")
    
    Grid.Rows = Grid.Rows + 1
    Grid.Row = Grid.Row + 1
           
    Grid.Col = 1
    Grid.Text = "Average"
    Grid.Col = 2
    Grid.Text = rs(0).Value
    
    'Get the 7th result set
    Set rs = db.OpenRecordset("SPrs6")
    
    Grid.Rows = Grid.Rows + 1
    Grid.Row = Grid.Row + 1
           
    Grid.Col = 0
    Grid.Text = "Total"
    Grid.Col = 1
    Grid.Text = "Average"
    Grid.Col = 2
    Grid.Text = rs(0).Value
    
    'Now clean up all of the temp qd objects
    rs.Close
    qd.Close
    db.Close
    
    MousePointer = vbDefault
    Exit Sub
   
Errorhandler:
    DisplayDAOError

    MousePointer = vbDefault

End Sub
Private Sub ShowError()
    
    Dim rs As Recordset
    Dim sSQL As String
    On Error GoTo Errorhandler
    
    sSQL = "Select * From no_such_table"
    Set rs = db.OpenRecordset(sSQL, dbOpenDynaset)
    rs.Close
    
    Exit Sub
    
Errorhandler:
    DisplayDAOError

End Sub
Private Sub Finish()
End Sub
Private Sub Reset()
    
    'Close any open connections
    db.Close

    'Initialize the program control values
    Label1.Visible = True
    Label2.Visible = True
    Grid.Visible = False
    Label_Top.Visible = False
    Text_Top.Visible = False
    Label_Mid.Caption = "User ID"
    Label_Mid.Visible = False
    Text_Mid.Visible = False
    Text_Mid.Enabled = True
    Label_Bot.Caption = "Password"
    Label_Bot.Visible = False
    Text_Bot.Visible = False
    Text_Bot.PasswordChar = "*"

    Text_Top.Text = sServer
    Text_Mid.Text = sLoginID
    Text_Bot.Text = sPassword
    
    Label1.Caption = sCase0_UpperText
    Label2.Caption = sCase0_LowerText

End Sub

Private Sub Command_Next_Click()
    If iLabel < 23 Then
        lbl_Functions(iLabel + 1).Enabled = True
        lbl_Functions(iLabel).Enabled = False
    End If
    
    Select Case nState
        Case 1
            'Get the Server, Login and Password that are required to connect
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Visible = False
            Label_Top.Visible = True
            Label_Mid.Visible = True
            Label_Bot.Visible = True
            Text_Top.Visible = True
            Text_Mid.Visible = True
            Text_Bot.Visible = True
            Text_Top.SetFocus
            Label2.Caption = sCase1_LowerText
        Case 2
            sServer = Text_Top.Text
            sLoginID = Text_Mid.Text
            sPassword = Text_Bot.Text
            ConnectLinkedTable
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Visible = True
            Label_Top.Visible = False
            Label_Mid.Visible = False
            Label_Bot.Visible = False
            Text_Top.Visible = False
            Text_Mid.Visible = False
            Text_Bot.Visible = False
            Label1.Caption = sCase2_UpperText
            Label2.Caption = sCase2_LowerText
        Case 3
            CreateLinkedTable ws, db, td, rs, sServer, sLoginID, sPassword
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Caption = sCase3_UpperText
            Label2.Caption = sCase3_LowerText
        Case 4
            ConnectOpenDatabase ws, db, sLoginID, sPassword
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Caption = sCase4_UpperText
            Label2.Caption = sCase4_LowerText
        Case 5
            DSNlessConnectOpenDatabase ws, db, sServer, sLoginID, sPassword
            nState = nState + 1
            Label1.Caption = sCase5_UpperText
            Label2.Caption = sCase5_LowerText
        Case 6
            DAOQuery
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 7
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase6_UpperText
            Label2.Caption = sCase6_LowerText
        Case 8
            DAORecordSetFindFirst db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 9
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase7_UpperText
            Label2.Caption = sCase7_LowerText
        Case 10
            DAORecordSetFindNext db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 11
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase8_UpperText
            Label2.Caption = sCase8_LowerText
        Case 12
            DAORecordsetFindLast rs
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase9_UpperText
            Label2.Caption = sCase9_LowerText
        Case 14
            DAOLimitedRecordSet
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 15
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase10_UpperText
            Label2.Caption = sCase10_LowerText
        Case 16
            CreateTable db
            nState = nState + 1
            Label1.Caption = sCase11_UpperText
            Label2.Caption = sCase11_LowerText
        Case 17
            AddUsingRecordset db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 18
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase12_UpperText
            Label2.Caption = sCase12_LowerText
        Case 19
            UpdateUsingRecordset db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 20
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase13_UpperText
            Label2.Caption = sCase13_LowerText
        Case 21
            DeleteUsingRecordset db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 22
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase14_UpperText
            Label2.Caption = sCase14_LowerText
        Case 23
            AddUsingInsert db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 24
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase15_UpperText
            Label2.Caption = sCase15_LowerText
        Case 25
            UpdateUsingUpdate db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 26
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase16_UpperText
            Label2.Caption = sCase16_LowerText
        Case 27
            DeleteUsingDelete db
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 28
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase17_UpperText
            Label2.Caption = sCase17_LowerText
        Case 29
            QueryDefParms
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 30
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase18_UpperText
            Label2.Caption = sCase18_LowerText
        Case 31
            QDSQLPassthru
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 32
            ShiftLabels iLabel - 13
            nState = nState + 1
            Grid.Visible = False
            Label1.Caption = sCase19_UpperText
            Label2.Caption = sCase19_LowerText
        Case 33
            CallQDsp
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = True
        Case 34
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase20_UpperText
            Label2.Caption = sCase20_LowerText
        Case 35
            ShowError
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Grid.Visible = False
            Label1.Caption = sCase21_UpperText
            Label2.Caption = sCase21_LowerText
        Case 36
            Finish
            ShiftLabels iLabel - 13
            nState = nState + 1
            iLabel = iLabel + 1
            Label1.Caption = sCase22_UpperText
            Label2.Caption = sCase22_LowerText
        Case 37
            lbl_Functions(iLabel - 13).Visible = False
            Reset
            nState = 1
            iLabel = 1
            ResetLabels
            lbl_Functions(1).Enabled = True
        End Select
End Sub

Private Sub Form_Activate()
    ' reposition the last labels
    PositionLabels
End Sub

Private Sub Form_Load()
    ' build labels
    BuildLabels
    
    ' set up object if to resize
    InitObjectsToResize Me
    
    'Initialize the program control values
    nState = 1
    iLabel = 1
    Label_Top.Visible = False
    Text_Top.Visible = False
    Label_Mid.Visible = False
    Text_Mid.Visible = False
    Label_Bot.Visible = False
    Text_Bot.Visible = False
    Grid.Visible = False
    
    Grid.Rows = 1
    Grid.Cols = 2
    Grid.Row = 0

    Label1.Caption = sCase0_UpperText
    Label2.Caption = sCase0_LowerText
    
End Sub
Private Sub Form_Resize()
    ' resize the forms objects
    ResizeObjects Me
End Sub

Private Sub DisplayDynasetGrid(rs As Recordset, Grid As MSFlexGrid, nDirection As Integer)
    
'    Dim fld As Field
'    Dim nForward As Integer
'    Dim nReverse As Integer
'    On Error Resume Next
'
'    nForward = 1
'    nReverse = 2
'
'    ' Setup the grid
'    Grid.Cols = rs.Fields.Count
'    rs.MoveLast
'    Grid.Rows = rs.RecordCount + 1
'    Grid.Row = 0
'    Grid.Col = 0
'    Grid.FixedRows = 1
'    Grid.Clear
'
'    'Setup the Grid headings
'     For Each fld In rs.Fields
'         If rs.EOF = False Then
'            Grid.ColWidth(Grid.Col) = TextWidth(String(Len(fld.Name) + 4, "a"))
'         End If
'         Grid.Col = fld.OrdinalPosition
'         Grid.Text = fld.Name
'         Grid.ColAlignment(Grid.Col) = 1
'    Next fld
'
'    If nDirection = nForward Then
'
'        rs.MoveFirst
'
'        ' Move through each row in the record set
'        Do Until rs.EOF
'
'            ' Set the position in the grid
'            Grid.Row = Grid.Row + 1
'            Grid.Col = 0
'
'            'Loop through all fields
'            For Each fld In rs.Fields
'                Grid.Col = fld.OrdinalPosition
'                If Grid.ColWidth(Grid.Col) < TextWidth(String(Len(fld.Value) + 4, "a")) Then
'                    Grid.ColWidth(Grid.Col) = TextWidth(String(Len(fld.Value) + 4, "a"))
'                End If
'                Grid.Text = fld.Value
'            Next fld
'
'            rs.MoveNext
'        Loop
'
'    Else
'
'        rs.MoveLast
'
'        ' Move through each row in the record set
'        Do Until rs.BOF
'
'            ' Set the position in the grid
'            Grid.Row = Grid.Row + 1
'            Grid.Col = 0
'
'            'Loop through all fields
'            For Each fld In rs.Fields
'                Grid.Col = fld.OrdinalPosition
'                If Grid.ColWidth(Grid.Col) < TextWidth(String(fld.Size + 4, "a")) Then
'                    Grid.ColWidth(Grid.Col) = TextWidth(String(fld.Size + 4, "a"))
'                End If
'                Grid.Text = fld.Value
'            Next fld
'
'            rs.MovePrevious
'
'        Loop
'
'    End If
    Dim fld As Field
    Dim nForward As Integer
    Dim nReverse As Integer
    On Error Resume Next
    
    nForward = 1
    nReverse = 2
    
    ' Setup the grid
    Grid.Redraw = False
    Grid.Cols = rs.Fields.Count
    rs.MoveLast
    Grid.Rows = rs.RecordCount + 1
    Grid.Row = 0
    Grid.Col = 0
    Grid.FixedRows = 1
    Grid.Clear
            
    'Setup the Grid headings
     For Each fld In rs.Fields
        Grid.Row = 0
         Grid.Col = fld.OrdinalPosition
         Grid.Text = fld.Name
         Grid.ColAlignment(Grid.Col) = 1
         Grid.ColWidth(Grid.Col) = Me.TextWidth(fld.Value & "AA")
    Next fld
    
    If nDirection = nForward Then
    
        rs.MoveFirst
    
        ' Move through each row in the record set
        Do Until rs.EOF
        
            ' Set the position in the grid
            Grid.Row = Grid.Row + 1
            Grid.Col = 0
        
            'Loop through all fields
            For Each fld In rs.Fields
                Grid.Col = fld.OrdinalPosition
                Grid.Text = fld.Value
                If Grid.ColWidth(Grid.Col) < Me.TextWidth(fld.Value & "AA") Then
                    Grid.ColWidth(Grid.Col) = Me.TextWidth(fld.Value & "AA")
                End If
            Next fld
    
            rs.MoveNext
        Loop

    Else

        rs.MoveLast
        
        ' Move through each row in the record set
        Do Until rs.BOF
        
            ' Set the position in the grid
            Grid.Row = Grid.Row + 1
            Grid.Col = 0
        
            'Loop through all fields
            For Each fld In rs.Fields
                Grid.Col = fld.OrdinalPosition
                Grid.Text = fld.Value
                If Grid.ColWidth(Grid.Col) < Me.TextWidth(fld.Value & "AA") Then
                    Grid.ColWidth(Grid.Col) = Me.TextWidth(fld.Value & "AA")
                End If
            Next fld
    
            rs.MovePrevious
            
        Loop

    End If
    
    Grid.Redraw = True
End Sub

Private Sub DisplayDAOError()
        
    Dim er As Error
    
    For Each er In Errors
        MsgBox "Number: " & er.Number & vbCrLf & _
        "Source: " & er.Source & vbCrLf & _
        "Text: " & er.Description
    Next
        
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    On Error Resume Next
    
    Set DBEngine = Nothing
    
End Sub
Private Sub Command_Cancel_Click()
    End
End Sub
Public Sub InitObjectsToResize(frm As Form)
    Dim obj As Object
    On Error Resume Next
    For Each obj In frm.Controls
        If obj.Left < 0 Then obj.Left = 0
        If obj.Top < 0 Then obj.Top = 0
        If obj.Top > frm.ScaleHeight Then obj.Top = frm.ScaleHeight - 360
        If obj.Width > frm.ScaleWidth Then obj.Width = frm.ScaleWidth
        If obj.Height > frm.ScaleHeight Then obj.Height = frm.ScaleHeight
        obj.Tag = Format$(obj.Left / frm.ScaleWidth, ".0000") _
                & Format$(obj.Top / frm.ScaleHeight, ".0000") _
                & Format$(obj.Width / frm.ScaleWidth, ".0000") _
                & Format$(obj.Height / frm.ScaleHeight, ".0000")
    Next obj
End Sub

Public Sub ResizeObjects(frm As Form)
    Dim obj As Object
    On Error Resume Next
    For Each obj In frm.Controls
        obj.Move Val(Mid$(obj.Tag, 1, 5)) * frm.ScaleWidth, _
                Val(Mid$(obj.Tag, 6, 5)) * frm.ScaleHeight, _
                Val(Mid$(obj.Tag, 11, 5)) * frm.ScaleWidth, _
                Val(Mid$(obj.Tag, 16, 5)) * frm.ScaleHeight
    Next obj
    
    intTop = lbl_Functions(2).Top - lbl_Functions(1).Top
    PositionLabels
End Sub

Public Sub BuildLabels()
    Dim iCount, iTop As Integer
    
    iTop = 1200
    For iCount = 1 To 23
        Set lbl_Functions(iCount) = Form1.Controls.Add("VB.Label", "lbl_Functions" & iCount, Me)
        lbl_Functions(iCount).AutoSize = True
        lbl_Functions(iCount).Enabled = False
        lbl_Functions(iCount).Height = 195
        lbl_Functions(iCount).Left = 230
        lbl_Functions(iCount).Top = iTop
        lbl_Functions(iCount).Visible = True
        Select Case iCount
            Case 1
                lbl_Functions(iCount).Caption = "Connection Information"
                lbl_Functions(iCount).Enabled = True
            Case 2
                lbl_Functions(iCount).Caption = "Connect w/Linked Table"
            Case 3
                lbl_Functions(iCount).Caption = "Create Linked Table"
            Case 4
                lbl_Functions(iCount).Caption = "DSN Connection"
            Case 5
                lbl_Functions(iCount).Caption = "DSN-less Connection"
            Case 6
                lbl_Functions(iCount).Caption = "Dynaset Recordset"
            Case 7
                lbl_Functions(iCount).Caption = "FindFirst Query"
            Case 8
                lbl_Functions(iCount).Caption = "FindNext Query"
            Case 9
                lbl_Functions(iCount).Caption = "FindLast/FindPrevious"
            Case 10
                lbl_Functions(iCount).Caption = "Limited Recordset"
            Case 11
                lbl_Functions(iCount).Caption = "Create Table"
            Case 12
                lbl_Functions(iCount).Caption = "Add w/Recordset"
            Case 13
                lbl_Functions(iCount).Caption = "Update w/Recordset"
            Case 14
                lbl_Functions(iCount).Caption = "Delete w/Recordset"
            ' build controls on page to allow resizing. will position them later
            Case 15
                lbl_Functions(iCount).Top = iTop - 360
                lbl_Functions(iCount).Caption = "Add w/SQL Passthru"
            Case 16
                lbl_Functions(iCount).Top = iTop - 360
                lbl_Functions(iCount).Caption = "Update w/SQL Passthru"
            Case 17
                lbl_Functions(iCount).Top = iTop - 360 * 2
                lbl_Functions(iCount).Caption = "Delete w/SQL Passthru"
            Case 18
                lbl_Functions(iCount).Top = iTop - 360 * 3
                lbl_Functions(iCount).Caption = "QueryDef"
            Case 19
                lbl_Functions(iCount).Top = iTop - 360 * 4
                lbl_Functions(iCount).Caption = "SQL Passthru QueryDef"
            Case 20
                lbl_Functions(iCount).Top = iTop - 360 * 5
                lbl_Functions(iCount).Caption = "Call Stored Procedure"
            Case 21
                lbl_Functions(iCount).Top = iTop - 360 * 6
                lbl_Functions(iCount).Caption = "Show Error"
            Case 22
                lbl_Functions(iCount).Top = iTop - 360 * 7
                lbl_Functions(iCount).Caption = "Finish"
            Case 23
                lbl_Functions(iCount).Top = iTop - 360 * 8
                lbl_Functions(iCount).Caption = "Reset"
        End Select
        iTop = iTop + 360
    Next iCount
    intTop = 360
End Sub

Public Sub PositionLabels()
    Dim iScrollMove, iTop As Integer
    iTop = (intTop * 14) + lbl_Functions(1).Top
    For iScrollMove = 1 To 9
        lbl_Functions(iScrollMove + 14).Top = iTop
        iTop = iTop + intTop
    Next iScrollMove
End Sub

Public Sub ResetLabels()
    Dim iScrollMove, iTop As Integer
    iTop = (intTop * 9) + lbl_Functions(1).Top
    For iScrollMove = 1 To 23
        lbl_Functions(iScrollMove).Visible = True
        lbl_Functions(iScrollMove).Top = iTop
        iTop = iTop + intTop
    Next iScrollMove
End Sub

Public Sub ShiftLabels(iShift As Integer)
    Dim iMove As Integer
    lbl_Functions(iShift).Visible = False
    For iMove = 1 To 14
        lbl_Functions(iMove).Top = (Val(Mid$(lbl_Functions(iMove).Tag, 6, 5)) * Me.ScaleHeight) - (intTop * iShift)
    Next iMove
    For iMove = 15 To 23
        lbl_Functions(iMove).Top = lbl_Functions(iMove).Top - intTop
    Next iMove
End Sub


