VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SQL Server Developer's Guide - SQLDMO Sample"
   ClientHeight    =   5865
   ClientLeft      =   1365
   ClientTop       =   1905
   ClientWidth     =   9615
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5865
   ScaleWidth      =   9615
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   7800
      TabIndex        =   21
      Top             =   5280
      Width           =   1575
   End
   Begin VB.ComboBox cboServer 
      Height          =   315
      Left            =   240
      TabIndex        =   18
      Top             =   1680
      Width           =   1935
   End
   Begin VB.CommandButton cmdListKeys 
      Caption         =   "Show Keys"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6000
      TabIndex        =   17
      Top             =   5280
      Width           =   1575
   End
   Begin VB.CommandButton cmdCopyTable 
      Caption         =   "Copy Table"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4200
      TabIndex        =   16
      Top             =   5280
      Width           =   1575
   End
   Begin VB.CommandButton cmdCreateDB 
      Caption         =   "Create Database"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2400
      TabIndex        =   15
      Top             =   5280
      Width           =   1575
   End
   Begin VB.ListBox lstDatabases 
      Height          =   3375
      Left            =   2400
      Sorted          =   -1  'True
      TabIndex        =   3
      Top             =   1680
      Width           =   1575
   End
   Begin VB.Frame Frame2 
      Caption         =   "Logon Information"
      Height          =   2895
      Left            =   240
      TabIndex        =   6
      Top             =   2160
      Width           =   1935
      Begin VB.OptionButton optSQLSecurity 
         Caption         =   "SQL Server Authentication"
         Height          =   375
         Left            =   240
         TabIndex        =   20
         Top             =   720
         Width           =   1335
      End
      Begin VB.OptionButton optNTSecurity 
         Caption         =   "NT Authetication"
         Height          =   255
         Left            =   240
         TabIndex        =   19
         Top             =   360
         Width           =   1575
      End
      Begin VB.TextBox txtPwd 
         Enabled         =   0   'False
         Height          =   405
         IMEMode         =   3  'DISABLE
         Left            =   240
         PasswordChar    =   "*"
         TabIndex        =   1
         Top             =   2280
         Width           =   1335
      End
      Begin VB.TextBox txtLogin 
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   0
         Top             =   1560
         Width           =   1335
      End
      Begin VB.Label lblPwd 
         Caption         =   "Password:"
         Enabled         =   0   'False
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   2040
         Width           =   1335
      End
      Begin VB.Label lblLogin 
         Caption         =   "User ID:"
         Enabled         =   0   'False
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   1320
         Width           =   1335
      End
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   5280
      Width           =   1935
   End
   Begin VB.ListBox lstTables 
      Height          =   3375
      Left            =   4200
      Sorted          =   -1  'True
      TabIndex        =   4
      Top             =   1680
      Width           =   1575
   End
   Begin VB.ListBox lstColumns 
      Height          =   3375
      Left            =   6000
      TabIndex        =   5
      Top             =   1680
      Width           =   1575
   End
   Begin VB.TextBox txtAttributes 
      Enabled         =   0   'False
      Height          =   3375
      Left            =   7800
      MultiLine       =   -1  'True
      TabIndex        =   7
      Top             =   1680
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Databases"
      Height          =   255
      Left            =   2520
      TabIndex        =   14
      Top             =   1320
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "SQL Server"
      Height          =   255
      Left            =   360
      TabIndex        =   13
      Top             =   1320
      Width           =   1455
   End
   Begin VB.Label Label5 
      Caption         =   "Tables"
      Height          =   255
      Left            =   4320
      TabIndex        =   12
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "Columns"
      Height          =   255
      Left            =   6120
      TabIndex        =   11
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label Label7 
      Caption         =   "Attributes"
      Height          =   255
      Left            =   7920
      TabIndex        =   10
      Top             =   1320
      Width           =   975
   End
   Begin VB.Image Image1 
      Height          =   1095
      Left            =   0
      Picture         =   "DMOSample.frx":0000
      Stretch         =   -1  'True
      Top             =   0
      Width           =   9615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim oSQLServer As New SQLDMO.SQLServer

Private Sub cmdCancel_Click()
    oSQLServer.DisConnect
    Set oSQLServer = Nothing
    End
End Sub

Private Sub cmdConnect_Click()

    Dim oDatabase As SQLDMO.Database
    
    On Error GoTo ConnectError
    
    MousePointer = vbHourglass
    
    ' Setup a secure login for NT security
    If Form1.optNTSecurity.Value = True Then
        oSQLServer.LoginSecure = True
    End If

    ' Connect to the selected SQL Server system
    oSQLServer.Connect cboServer.Text, txtLogin.Text, txtPwd.Text
        
    ' Disable the Connect button
    cmdConnect.Enabled = False

    ' List the databases
    For Each oDatabase In oSQLServer.Databases
        If oDatabase.Status <> SQLDMODBStat_Inaccessible Then
            lstDatabases.AddItem oDatabase.Name
        End If
    Next oDatabase

    ' Populate the other list boxes
    lstDatabases_Click
    
    ' Enable all of the other buttons
    cmdCreateDB.Enabled = True
    cmdCopyTable.Enabled = True
    cmdListKeys.Enabled = True

    MousePointer = vbDefault
    Exit Sub
    
ConnectError:
    SQLDMOError
    MousePointer = vbDefault
    
End Sub

Public Function SQLDMOError()
    
    Dim sErrorMsg As String
    
    sErrorMsg = Err.Source & " Error: " & _
                Err.Number - vbObjectError & ": " & Err.Description

    SQLDMOError = MsgBox(sErrorMsg, vbOKOnly, "SQL-DMO Error")

End Function

Private Sub cmdCopyTable_Click()
    Dim oCurDatabase As SQLDMO.Database
    Dim oCopyTable As New SQLDMO.Table
    Dim oSourceTable As SQLDMO.Table
    Dim oSourceColumn As SQLDMO.Column
    Dim oColumn As SQLDMO.Column
    
    Dim i As Long
    Dim sScript As String
    Dim lPos As Long
    Dim sNewTableName As String
    
    On Error GoTo CopyTable_Err

    ' Set the database object from the current list selection
    If lstDatabases.ListIndex >= 0 Then
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
    Else
        Set oCurDatabase = oSQLServer.Databases(1)
    End If
    
    ' Prompt for new table name
    sNewTableName = InputBox("Enter new table name", "Table:")
    
    ' Make sure that the table name isn't already used
    On Error Resume Next
    
    If oCurDatabase.Tables(sNewTableName).Name = "" Then
    End If
    
    If Err = 0 Then
        MsgBox sNewTableName & " already exists!"
        GoTo CopyTable_Exit
    Else
        On Error GoTo CopyTable_Err
    End If
       
    ' Set the source table object from the current list selection
    If lstTables.ListIndex >= 0 Then
        Set oSourceTable = oCurDatabase.Tables _
          (lstTables.List(lstTables.ListIndex))
    Else
        Set oSourceTable = oCurDatabase.Tables(1)
    End If
    
    For Each oSourceColumn In oSourceTable.Columns
        ' Create column clones
        Set oColumn = CreateObject("SQLDMO.Column")
        oColumn.AllowNulls = oSourceColumn.AllowNulls
        oColumn.Datatype = oSourceColumn.Datatype
        oColumn.Length = oSourceColumn.Length
        
        oColumn.Identity = oSourceColumn.Identity
        oColumn.IdentityIncrement = oSourceColumn.IdentityIncrement
        oColumn.IdentitySeed = oSourceColumn.IdentitySeed
        
        oColumn.NumericPrecision = oSourceColumn.NumericPrecision
        oColumn.NumericScale = oSourceColumn.NumericScale
        oColumn.Name = oSourceColumn.Name
        
        ' Do the DRIDefaults
        If oSourceColumn.DRIDefault.Name <> "" Then
            i = i + 1
            oColumn.DRIDefault.Name = "DF_" _
                & Mid$(sNewTableName, 1, 10) _
                & "_" & Mid$(oSourceColumn.Name, 1, 10) _
                & "_" & Format$(i, "000")
            oColumn.DRIDefault.Text = oSourceColumn.DRIDefault.Text
        End If
        
        ' Add it to the table
        oCopyTable.Columns.Add oColumn
        oColumn.Default = oSourceColumn.Default
        Set oColumn = Nothing

    Next
    
    ' Add the table to the database
    oCopyTable.Name = sNewTableName
    oCurDatabase.Tables.Add oCopyTable
    
    ' Now transfer the primary keys and indexes
    For i = 1 To oSourceTable.Indexes.Count
        
        ' Get the index script
        sScript = _
            oSourceTable.Indexes(i).Script(SQLDMOScript_PrimaryObject)
        
        If sScript <> vbNullString Then
        
            ' Strip the GO
            lPos = 1
            lPos = InStr(lPos, sScript, "GO")
            sScript = Mid$(sScript, 1, lPos - 3)
            
            ' Replace the old table name in the script with the new name
            lPos = 1
            lPos = InStr(lPos, sScript, oSourceTable.Name)
            
            Do While lPos <> 0
                sScript = Mid$(sScript, 1, lPos - 1) & sNewTableName & _
                    Mid$(sScript, lPos + Len(oSourceTable.Name))
                lPos = lPos + Len(oSourceTable.Name)
                lPos = InStr(lPos, sScript, oSourceTable.Name)
            Loop
        
        End If
        
        ' Excute the script
        If sScript <> "" Then
            oCurDatabase.ExecuteImmediate sScript
        End If

    Next
    
    ' Refresh the table list
    lstTables.AddItem sNewTableName
    
CopyTable_Exit:
    On Error Resume Next
    
    Set oColumn = Nothing
    Set oSourceColumn = Nothing
    Set oSourceTable = Nothing
    Set oCopyTable = Nothing
    Set oCurDatabase = Nothing
    MousePointer = vbDefault

    Exit Sub

CopyTable_Err:
    SQLDMOError
    Resume CopyTable_Exit
End Sub

Private Sub cmdCreateDB_Click()
    
    Dim oDatabase As New SQLDMO.Database
    Dim oDBFile As New SQLDMO.DBFile
    Dim oLogFile As New SQLDMO.LogFile
    
    Dim sDatabaseName As String
    Dim sDBFilePath As String
    
    On Error GoTo CreateDB_Err
   
    'Input the database name
    sDatabaseName = InputBox("Enter the new database name", _
        "New Database")
    
    ' Make sure that the database name isn't already used
    On Error Resume Next
    If oSQLServer.Databases(sDatabaseName).Name = "" Then
    End If
    
    If Err = 0 Then
        MsgBox sDatabaseName & " already exists!"
        GoTo CreateDB_Exit
    Else
        On Error GoTo CreateDB_Err
    End If
    
    'Set the object's database name
    oDatabase.Name = sDatabaseName
    
    'Input the path for the data and log files
    sDBFilePath = InputBox("Enter the path for data and log files", _
      "New Database", _
      "c:\Program Files\Microsoft SQL Server\MSSQL\Data\" _
      & sDatabaseName)
    
   'Set the properties of the DBFile object
    oDBFile.Name = sDatabaseName & ".mdf"
    oDBFile.PhysicalName = sDBFilePath & ".mdf"
    
   'Add the DBFile object to the collection
    oDatabase.FileGroups("PRIMARY").DBFiles.Add oDBFile
    
   'Set the properties of the LogFile object
    oLogFile.Name = sDatabaseName & ".ldf"
    oLogFile.PhysicalName = sDBFilePath & ".ldf"
   
   'Add the LogFile object to the collection
    oDatabase.TransactionLog.LogFiles.Add oLogFile
  
   'Add the new DB object to the databases collection
    oSQLServer.Databases.Add oDatabase
   
   'Add the DB name to the list
    lstDatabases.AddItem oDatabase.Name
    
CreateDB_Exit:
    On Error Resume Next
    
    Set oLogFile = Nothing
    Set oDBFile = Nothing
    Set oDatabase = Nothing
    
    MousePointer = vbDefault

    Exit Sub

CreateDB_Err:
    SQLDMOError
    Resume CreateDB_Exit

End Sub

Private Sub cmdListKeys_Click()

    Dim oCurDatabase As SQLDMO.Database
    Dim oCurTable As SQLDMO.Table
    
    Dim oKeyList As SQLObjectList
    Dim oObject As Object
    Dim sColumnName As String
    Dim sKeyNames As String
    
    ' Get the selected column name
    If lstColumns.ListIndex >= 0 Then
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
        Set oCurTable = oCurDatabase.Tables _
          (lstTables.List(lstTables.ListIndex))
        sColumnName = lstColumns.List(lstColumns.ListIndex)
    Else ' otherwise pick the first column
        If lstDatabases.ListIndex < 0 Then lstDatabases.ListIndex = 0
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
        
        If lstTables.ListIndex < 0 Then lstTables.ListIndex = 0
        Set oCurTable = oCurDatabase.Tables _
          (lstTables.List(lstTables.ListIndex))
        
        If lstColumns.ListIndex < 0 Then lstColumns.ListIndex = 0
        sColumnName = lstColumns.List(lstColumns.ListIndex)
    End If

    ' Populate the keys collection
    Set oKeyList = oCurTable.Columns(sColumnName).ListKeys
    
    ' Add the names as a list to a string
    For Each oObject In oKeyList
        sKeyNames = sKeyNames & oObject.Name & vbCrLf
    Next
    
    ' Display none if the list is empty
    If sKeyNames = vbNullString Then
        sKeyNames = "None"
    End If
    
    ' Display the list in a message box
    MsgBox sKeyNames, , "Keys Containing " & sColumnName

End Sub

Private Sub Form_Load()

    Dim oApplication As New SQLDMO.Application
    Dim oServerGroup As SQLDMO.ServerGroup
    Dim oRegisteredServer As SQLDMO.RegisteredServer

    ' Process all the server groups
    For Each oServerGroup In oApplication.ServerGroups
        ' Process each registered server
        For Each oRegisteredServer In oServerGroup.RegisteredServers
            ' Add each name to the combobox
            cboServer.AddItem oRegisteredServer.Name
        Next
    Next
    
    Set oRegisteredServer = Nothing
    Set oServerGroup = Nothing
    Set oApplication = Nothing
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    oSQLServer.DisConnect
    Set oSQLServer = Nothing
End Sub

Private Sub lstDatabases_Click()
    Dim oCurDatabase As SQLDMO.Database
    Dim oTable As SQLDMO.Table
    
    On Error GoTo DatabaseError
    
    ' Get the selected database name
    If lstDatabases.ListIndex >= 0 Then
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
    Else ' otherwise pick the first database
        Set oCurDatabase = oSQLServer.Databases(1)
    End If
    
    ' Clear the dependant objects
    lstTables.Clear
    lstColumns.Clear
    txtAttributes.Text = vbNullString
    
    ' Add the table names to the list
    For Each oTable In oCurDatabase.Tables
        lstTables.AddItem oTable.Name
    Next oTable
    
    ' Populate the dependant objects
    lstTables_Click
    Exit Sub
    
DatabaseError:
    SQLDMOError
    
End Sub

Private Sub lstTables_Click()
    Dim oCurDatabase As SQLDMO.Database
    Dim oCurTable As SQLDMO.Table
    Dim oColumn As SQLDMO.Column
    
    On Error GoTo TableError
    
    ' Get the selected table name
    If lstTables.ListIndex >= 0 Then
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
        Set oCurTable = oCurDatabase.Tables _
          (lstTables.List(lstTables.ListIndex))
    Else ' otherwise pick the first table
        If lstDatabases.ListIndex < 0 Then _
          lstDatabases.ListIndex = 0
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
        
        If lstTables.ListIndex < 0 Then _
          lstTables.ListIndex = 0
        Set oCurTable = oCurDatabase.Tables _
          (lstTables.List(lstTables.ListIndex))
    End If
    
    ' Clear the dependant objects
    lstColumns.Clear
    txtAttributes.Text = vbNullString
    
On Error Resume Next
    
    ' Add the column names to the list
    For Each oColumn In oCurTable.Columns
        lstColumns.AddItem oColumn.Name
    Next oColumn
    
    ' Populate the dependant objects
    lstColumns_Click
    Exit Sub
    
TableError:
    SQLDMOError

End Sub

Private Sub lstColumns_Click()
    Dim oCurDatabase As SQLDMO.Database
    Dim oCurTable As SQLDMO.Table
    Dim oColumn As SQLDMO.Column
    Dim sColumnName As String
    
    On Error GoTo ColumnError
    
    ' Get the selected column name
    If lstColumns.ListIndex >= 0 Then
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
        Set oCurTable = oCurDatabase.Tables _
          (lstTables.List(lstTables.ListIndex))
        sColumnName = lstColumns.List(lstColumns.ListIndex)
    Else ' otherwise pick the first column
        If lstDatabases.ListIndex < 0 Then lstDatabases.ListIndex = 0
        Set oCurDatabase = oSQLServer.Databases _
          (lstDatabases.List(lstDatabases.ListIndex))
        
        If lstTables.ListIndex < 0 Then lstTables.ListIndex = 0
        Set oCurTable = oCurDatabase.Tables _
          (lstTables.List(lstTables.ListIndex))
        
        If lstColumns.ListIndex < 0 Then lstColumns.ListIndex = 0
        sColumnName = lstColumns.List(lstColumns.ListIndex)
    End If
    
    ' Clear the dependant objects
    txtAttributes.Text = vbNullString
    
    ' Add the attributes to the textbox
    txtAttributes.Text = oCurTable.Columns(sColumnName).Name _
        & vbCrLf & vbCrLf _
        & "Data Type:" & vbCrLf _
        & oCurTable.Columns(sColumnName).Datatype & vbCrLf & vbCrLf _
        & "Length:" & vbCrLf _
        & oCurTable.Columns(sColumnName).Length & vbCrLf & vbCrLf _
        & "Precision:" & vbCrLf _
        & oCurTable.Columns(sColumnName).NumericPrecision & vbCrLf & vbCrLf _
        & "Scale:" & vbCrLf _
        & oCurTable.Columns(sColumnName).NumericScale
                           
    Exit Sub
    
ColumnError:
    SQLDMOError
    
End Sub

Private Sub optNTSecurity_Click()
    optSQLSecurity.Value = False
    lblLogin.Enabled = False
    txtLogin.Enabled = False
    lblPwd.Enabled = False
    txtPwd.Enabled = False
End Sub

Private Sub optSQLSecurity_Click()
    optNTSecurity.Value = False
    lblLogin.Enabled = True
    txtLogin.Enabled = True
    lblPwd.Enabled = True
    txtPwd.Enabled = True
End Sub

